<?php

class Sample_Cash_PaymentController extends Mage_Core_Controller_Front_Action
{
    /**
     * Redirect to unitpay
     */
    public function redirectAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setRobokassaQuoteId($session->getQuoteId());
        $this->getResponse()->setBody($this->getLayout()->createBlock('cash/redirect')->toHtml());
        $session->unsQuoteId();
        $session->unsRedirectUrl();
    }

    /**
     * When a customer cancel payment from unitpay.
     */
    public function failAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getUnitpayQuoteId());
        if ($session->getLastRealOrderId()) {
            $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
            if ($order->getId()) {
                $order->cancel()->save();
            }

        }

        $quote = Mage::getModel('sales/quote')->load($session->getUnitpayQuoteId());
        if ($quote->getId()) {
            $quote->setActive(true);
            $quote->save();
        }
        $session->addError(Mage::helper('cash')->__('Payment failed. Pleas try again later.'));
        $this->_redirect('checkout/cart');
    }

    /**
     * Customer return processing
     */
    public function returnAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getUnitpayQuoteId());
        Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();
        $this->_redirect('checkout/onepage/success', array('_secure'=>true));
    }

	 public function reqconf($order)
    {
	$paymentMethod = Mage::getModel('cash/redirect');
		$key= $paymentMethod->getCashSecret();
		$auth= $paymentMethod->getCashLogin();
	$sign = md5('complete-' . $order . '-' . $key);
	$xml = '
			<?xml version="1.0" encoding="utf-8"?>
			<cash24 xmlns="http://api.cash24.ru/1.0/">
			  <request xmlns="http://api.cash24.ru/1.0/complete/">
				<order>' . $order . '</order>
			  </request>
			  <envelope>
				<auth>' . $auth . '</auth>
				<sign>' . $sign . '</sign>
			  </envelope>
			</cash24>
		';
		$respurl="https://api.cash24.ru/1.0/";
		 $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, trim($xml));
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
	 
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
	
		return $out;
	}
	
	 public function reqcancel($order)
    {
	$paymentMethod = Mage::getModel('cash/redirect');
		$key= $paymentMethod->getCashSecret();
		$auth= $paymentMethod->getCashLogin();
	$sign = md5('reversal-' . $order . '-' . $key);
	$xml = '
			<?xml version="1.0" encoding="utf-8"?>
			<cash24 xmlns="http://api.cash24.ru/1.0/">
			  <request xmlns="http://api.cash24.ru/1.0/reversal/">
				<order>' . $order . '</order>
			  </request>
			  <envelope>
				<auth>' . $auth . '</auth>
				<sign>' . $sign . '</sign>
			  </envelope>
			</cash24>
		';
		
		$respurl="https://api.cash24.ru/1.0/";
		 $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, trim($xml));
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
	 
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
	
		return $out;
	}
	 public function confirmholdAction()
    {
	 $get = $this->getRequest()->getParams();
	$out= $this->reqconf($get['order_real_id']);
	
	 $url = new SimpleXMLElement($out);
	if($url->envelope->error !='0'){
	Mage::getModel('core/cookie')->set('error', $url->envelope->text, $period, $path, $domain, $secure, $httponly);
	}else{
	
	$order = Mage::getModel('sales/order')->loadByIncrementId($get['order_real_id']);

	$order->setStatus('complete');
	$order->setIsNotified(false);
        $order->save();
	}
	
        $this->_redirect('adminhtml/sales_order/view/order_id/' . $get['order_id']);
    }
	
	 public function cancelholdAction()
    {
	 $get = $this->getRequest()->getParams();
	$out= $this->reqcancel($get['order_real_id']);
	
	 $url = new SimpleXMLElement($out);
	if($url->envelope->error !='0'){
	
	Mage::getModel('core/cookie')->set('error', $url->envelope->text, $period, $path, $domain, $secure, $httponly);
	} else {
	
	$order = Mage::getModel('sales/order')->loadByIncrementId($get['order_real_id']);
	
	$order->setStatus('refund');
	$order->setIsNotified(false);
        $order->save();
	}
	
        $this->_redirect('adminhtml/sales_order/view/order_id/' . $get['order_id']);
    }
	
    /**
     * Background notifications
     */
    public function notifyAction()
    {
  $request = $_POST;
  
  $order = Mage::getModel('sales/order')->loadByIncrementId($request['order']);
  if($orderItem->grand_total > $request['amount']){
exit;
}
$paymentMethod = Mage::getModel('cash/redirect');
		$key= $paymentMethod->getCashSecret();
$toSign = 'callback';
$toSign .= '-' . $request['status'];
$toSign .= '-' . $request['reason'];
$toSign .= '-' . $request['amount'];
$toSign .= '-' . $request['currency'];
$toSign .= '-' . $request['order'];
$toSign .= '-' . $request['url'];
$toSign .= '-' . $request['wallet'];
$toSign .= '-' . $request['method'];
$toSign .= '-' . $_request['available-for-refund'];
$toSign .= '-' . $request['refund-made-amount'];
$toSign .= '-' . $request['salt'];
$toSign .= '-' . $key;

	    if (strtoupper(md5($toSign)) != $request['sign'])
{
return -1;
exit;
}	
    
		if($request['status']=='20'){
		$order->setState(Mage_Sales_Model_Order::STATE_HOLDED);
 $order->setStatus('holded');
   $order->setIsNotified(false);
        $order->save();
		exit;
}
		if($request['status']=='30'){
		$order->setState(Mage_Sales_Model_Order::STATE_CANCELED);
 $order->setStatus('canceled');
   $order->setIsNotified(false);
        $order->save();
		exit;
}
	if($request['status']=='40'){	   
	  $order->setStatus('complete');
  $order->setIsNotified(false);
        $order->save();
		exit;
}
if($request['status']=='50'){
 $order->setStatus('refund');
}
       
      
		
    }
}

