<?php
class Sample_Cashcard_Model_Redirect extends Mage_Payment_Model_Method_Abstract
{
    protected $_code = 'cashcard_redirect';

    protected $_formBlockType = 'cashcard/message';

    /**
     * Payment Method features
     * 
     * @var bool
     */
    protected $_canUseForMultishipping  = false;
    protected $_canUseInternal          = false;
    protected $_isInitializeNeeded      = true;

    /**
     * Instantiate state and set it to state object
     * 
     * @param string $paymentAction
     * @param Varien_Object $stateObject
     */
    public function initialize($paymentAction, $stateObject)
    {
        $stateObject->setState(Mage_Sales_Model_Order::STATE_PENDING_PAYMENT);
        $stateObject->setStatus('pending_payment');
        $stateObject->setIsNotified(false);
        $stateObject->save();
    }

    /**
     * Return Order place redirect url
     *
     * @return string
     */
    public function getOrderPlaceRedirectUrl()
    {
          return Mage::getUrl('cashcard/payment/redirect', array('_secure' => true));
    }

    /**
     * Return unitpay place URL
     * 
     * @return string
     */
    public function getCashPlaceUrl()
    {
	   $session = Mage::getSingleton('checkout/session');
        $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
		
		$shipping_address = $order->getAddressById($order->getShippingAddressId()); 
	
	
        $time = time() + 24 * 60 * 60;
		$exptime=gmdate('Y-m-d', $time) . 'T' . gmdate('H:i:s', $time);
$arParams = array();
$arParams['amount']=$order->getBaseGrandTotal();
$arParams['currency']="RUB";
$arParams['email']=$order->customer_email;
$arParams['description']='Order #'.$order->getIncrementId();
$arParams['order']=$order->getIncrementId();
$arParams['success']=htmlspecialchars(Mage::getUrl());
$arParams['cancel']=htmlspecialchars(Mage::getUrl());
$arParams['callback']=htmlspecialchars(Mage::getUrl().'cash/payment/notify');
$arParams['method']='card';
$arParams['phone']=$shipping_address->telephone;
$arParams['wallet']='';
$arParams['expires']=$exptime;

function createInvoice($arParams,$auth,$key)
	{
		$auth = $auth;
		$commandSecretKey = $key;

		$request = '';
		$toSign = 'create-invoice';
		foreach ($arParams as $key => $val)
		{
			$request .= "<$key>" . $val . "</$key>\r\n";
			if ($key != 'expires' AND $key != 'phone')
				$toSign .= '-' . $val;
		}

		$sign = md5(htmlspecialchars_decode($toSign) . '-' . $commandSecretKey);

		$xml = '
			<?xml version="1.0" encoding="utf-8"?>
			<cash24 xmlns="http://api.cash24.ru/1.0/">
			  <request xmlns="http://api.cash24.ru/1.0/create-invoice/">
				' . $request . '
			  </request>
			  <envelope>
				<auth>' . $auth . '</auth>
				<sign>' . $sign . '</sign>
			  </envelope>
			</cash24>
		';

		return trim($xml);
	}
$headers = array(
    "Content-type: text/xml"
    
);
$k= createInvoice($arParams,$this->getConfigData('login'),$this->getConfigData('password2'));
$respurl="https://api.cash24.ru/1.0/";
		 $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $k);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
	 
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
	
$url = new SimpleXMLElement($out);
$turl= $url;
		$url = $url->response->url; //формируем строку url
		if(!empty($turl->envelope->error)){
		echo $turl->envelope->text;
		exit;
		}
		return $url;
    }
	  public function getUnitpaySecret()
    {
        return $this->getConfigData('password1');
    }

    /**
     * Return redirect form fields
     * @return array
     */
    public function getRedirectFormFields()
    {
        $result = array();
        $session = Mage::getSingleton('checkout/session');
        $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
        
        if (!$order->getId()) {
            return $result;
        }

       
        $result['sum'] = $order->getBaseGrandTotal();
        $result['account'] = $order->getIncrementId();
        $result['desc'] = 'Shopping in '. Mage::getStoreConfig(Mage_Core_Model_Store::XML_PATH_STORE_STORE_NAME);
             
        return $result;
    }

    /**
     * Check incoming request CRC
     *
     * @param array $request
     * @return bool
     */
   


}