<?php
class Sample_Cashyandex_PaymentController extends Mage_Core_Controller_Front_Action
{
    /**
     * Redirect to unitpay
     */
    public function redirectAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setRobokassaQuoteId($session->getQuoteId());
        $this->getResponse()->setBody($this->getLayout()->createBlock('cashyandex/redirect')->toHtml());
        $session->unsQuoteId();
        $session->unsRedirectUrl();
    }

    /**
     * When a customer cancel payment from unitpay.
     */
    public function failAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getUnitpayQuoteId());
        if ($session->getLastRealOrderId()) {
            $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
            if ($order->getId()) {
                $order->cancel()->save();
            }

        }

        $quote = Mage::getModel('sales/quote')->load($session->getUnitpayQuoteId());
        if ($quote->getId()) {
            $quote->setActive(true);
            $quote->save();
        }
        $session->addError(Mage::helper('cash')->__('Payment failed. Pleas try again later.'));
        $this->_redirect('checkout/cart');
    }

    /**
     * Customer return processing
     */
    public function returnAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getUnitpayQuoteId());
        Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();
        $this->_redirect('checkout/onepage/success', array('_secure'=>true));
    }

    /**
     * Background notifications
     */
    public function notifyAction()
    {
      $payment = new UnitPay(
    new UnitPayEvent()
);

echo $payment->getResult();  
    }
}
class UnitPayEvent
{
    public function check($params)
    {    
            $arOrder = Mage::getModel('sales/order')->loadByIncrementId($params['account']);    
         
         if ($arOrder['increment_id'])
         {
            return true;      
         }  
         return 'Character not found';
    }

    public function pay($params)
    {
   $order = Mage::getModel('sales/order')->loadByIncrementId($params['account']);
        $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING);
        $order->setStatus('processing');
        $order->setIsNotified(false);
        $order->save();
    }
}
